public class Haupt {
    public static List<Integer> insertionsort(List<Integer> input) {
        List<Integer> sortiert = new List<Integer>();       

        while(!input.isEmpty()) {
            input.toFirst();
            Integer currentObject = input.getContent();
            input.remove();
            //            if(sortiert.isEmpty()) {
            //                sortiert.append(currentObject);
            //            } else {
            sortiert.toFirst();
            while((sortiert.hasAccess()) && (currentObject > sortiert.getContent())) {
                sortiert.next();
            }
            if(sortiert.hasAccess()) {
                // wir sind noch mitten in der sortierten Liste
                sortiert.insert(currentObject);
            } else {
                // wir sind am Ende der sortierten Liste
                sortiert.append(currentObject);
            }
            //            }

        }
        return sortiert;
    }

    public static List<Integer> mergesort(List<Integer> m) {
        int len = m.getLength();
        if(m.getLength() <= 1) {
            return m;
        }
        // Liste aufteilen
        List<Integer> m1 = m;        
        List<Integer> m2 = m1.cutInHalf();

        // Teile sortieren
        m1 = mergesort(m1);
        m2 = mergesort(m2);

        // zusammenfuegen (merge)
        m1.toFirst();
        m2.toFirst();

        List<Integer> result = new List<Integer>();
        while(m1.hasAccess() && m2.hasAccess()) {
            if(m1.getContent() < m2.getContent()) {
                result.append(m1.getContent());
                m1.remove();
            } else {
                result.append(m2.getContent());
                m2.remove();
            }
        }
        if(!m1.isEmpty()) {
            result.concat(m1);
        }
        if(!m2.isEmpty()) {
            result.concat(m2);
        }
        return result;

    }

    public static void main() {
        List<Integer> zahlen = new List<Integer>();
        zahlen.append(6);
        zahlen.append(9);
        zahlen.append(2);
        zahlen.append(8);
        zahlen.append(4);
        
        /*
        List<Integer> zahlen2 = zahlen.cutInHalf();
        System.out.println("----- Die erste Hälfte: -----");
        ausgabe(zahlen);
        System.out.println("Länge"+zahlen.getLength());
        System.out.println("----- Die zweite Hälfte: -----");
        ausgabe(zahlen2);
        System.out.println("Länge"+zahlen2.getLength());
         */

        List<Integer> sortiert = mergesort(zahlen);
        System.out.println("----- Sortiert: -----");
        ausgabe(sortiert);

    }

    public static void ausgabe(List<Integer> liste) {
        liste.toFirst();
        while(liste.hasAccess()) {
            System.out.println("Zahl: "+liste.getContent());
            liste.next();
        }
    }
}
